package prog2_aufgabe05;

import java.io.BufferedOutputStream;
import java.io.DataOutputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Random;
import javax.swing.JTextArea;

public class CreateThread extends Thread {

  private int nr = 0;
  private int maxItems = 0;
  private String filename = "";

  public CreateThread(int nr, int maxItems, String filename) {
    this.nr = nr;
    this.maxItems = maxItems;
    this.filename = filename;
  }

  /**
   * Erzeugt die Datei "filename" 
   * Schreibt als erstes die Anzahl der Bestellungen 
   * Schreibt danach die einzelnen Bestellungen mittels EINER Methode der Klasse Bestellung
   */
  public void run() {
    try {
      FileOutputStream fout = null;
      BufferedOutputStream bout = null;
      DataOutputStream dout = null;
      Bestellung best;
      Random generator = new Random();
      // System.out.println("i: "+nr);
      fout = new FileOutputStream(filename);
      bout = new BufferedOutputStream(fout);
      dout = new DataOutputStream(bout);
      dout.writeInt(maxItems);
      for (int j = 0; j < maxItems; j++) {
        best = new Bestellung(generator);
        best.write2File(dout);
      }
      dout.close();
      System.out.println("i: " + nr);
    } catch (IOException e) {
      System.err.println("IOException: " + e);
    }

  }
}
