package prog2_aufgabe05;

import java.io.*;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import javax.swing.JTextArea;

public class DataMiningThread extends Thread {

  private int nr = 0;
  private String searchBez = "";
  private String bstFilename = "";
  private String dataMiningFilename = "";
  private int anz = 0;

  public int getAnz() {
    return anz;
  }

  public DataMiningThread(int nr, String searchBez, String bstFilename,
          String dataMiningFilename) {
    this.nr = nr;
    this.searchBez = searchBez;
    this.bstFilename = bstFilename;
    this.dataMiningFilename = dataMiningFilename;
  }

  // miwi
  /**
   * Das DataMining wird nur fuer eine Datei durchgefuehrt 
   * ArrayList erstellen
   * lesen der i-ten Datei (bstFilename) 
   * pro Bestellung wird mittels in.....f der Suchstring gesucht 
   * wenn vorhanden, in die Liste eintragen 
   * Schliesst die Datei Anzahl speichern
   *
   * Schreiben der Daten der Liste in die i.te dm-datei (dataMiningFilename)
   * Schliesst die Datei Anzahl speichern
   */
  @Override
  public void run() {
    anz = 0;
    ArrayList<Bestellung> liste = new ArrayList<>();
    try {
      FileInputStream fin = null;
      DataInputStream din = null;
      BufferedInputStream bin = null;
      FileOutputStream fout = null;
      DataOutputStream dout = null;
      BufferedOutputStream bout = null;
      Bestellung best;

      fin = new FileInputStream(bstFilename);
      bin = new BufferedInputStream(fin);
      din = new DataInputStream(bin);
      int n = din.readInt();
      for (int j = 0; j < n; j++) {
        best = new Bestellung();
        best.readfromFile(din);
        if (best.getBezeichungen().indexOf(searchBez) >= 0) {
          liste.add(best);
        }
      }
      din.close();
      fout = new FileOutputStream(dataMiningFilename); // byteweise
      bout = new BufferedOutputStream(fout);
      dout = new DataOutputStream(bout);
      dout.writeInt(liste.size());
      for (Bestellung b : liste) {
        b.write2File(dout);
      }
      dout.close();
      System.out.println("i: " + nr + "   anz: " + liste.size());
      anz = liste.size();
    } catch (FileNotFoundException e1) {
      System.err.println("FileNotFoundException: " + e1);
    } catch (IOException e) {
      System.err.println("IOException: " + e);
    }

  }
}
